pipeline{
    //Directives
    agent any

    tools{
        maven 'maven-3.6.3'
    }
 environment{
       ArtifactId = readMavenPom().getArtifactId()
       Version = readMavenPom().getVersion()
       Name = readMavenPom().getName()
       GroupId = readMavenPom().getGroupId()
    }


   

    stages {
        // Specify various stage with in stages

        // stage 1. Build
        stage ('Build'){
            steps {
                sh 'mvn clean package'
            }
        }

        // Stage2 : Testing
        stage ('Test'){
            steps {
                echo ' testing......'

            }
        }
        //stage3:upload artofact to nexus repo
        stage('upload to Nexus repo'){
            steps{
                script{
                    def NexusRepo = Version.endsWith("SNAPSHOT") ? "DevOps-SNAPSHOT" : "DevOps-REALEASE"
                nexusArtifactUploader artifacts: [[artifactId: 
                "${ArtifactId}", classifier: '', 
                file: "target/${ArtifactId}-${Version}.war", type: 'war']],
                 credentialsId: '5a3c265d-dfee-4ff0-9f15-26be6b1bd728', 
                 groupId: "${GroupId}", nexusUrl:
                  '15.206.189.30:8081', 
                  nexusVersion: 'nexus3',
                   protocol: 'http', 
                   repository: "${NexusRepo}", 
                version: "${Version}"
                }
            }
        }

       // Stage 4 : Print some information
        stage ('Print Environment variables'){
                    steps {
                        echo "Artifact ID is '${ArtifactId}'"
                        echo "Version is '${Version}'"
                        echo "GroupID is '${GroupId}'"
                        echo "Name is '${Name}'"
                    }
                }
         // Stage 5 : Deploying the build artifact to Docker
        stage ('Deploy to Docker'){
            steps {
                echo "Deploying ...."
                sshPublisher(publishers: [sshPublisherDesc(configName: 'ansibleController', transfers: 
[sshTransfer(
cleanRemote: false, 
excludes: '',
 execCommand: 'ansible-playbook /opt/playbooks/downloadInstall2.yaml -i /opt/playbooks/hosts',
 execTimeout: 120000, flatten: false, makeEmptyDirs: false, noDefaultExcludes: false, patternSeparator: '[, ]+', remoteDirectory: '', remoteDirectorySDF: false, removePrefix: '', sourceFiles: '')], usePromotionTimestamp: false, useWorkspaceInPromotion: false, verbose: false)])
            
            }
        }

                
    }

}
